#ifndef ZONEMULTIPATH_H
#define ZONEMULTIPATH_H

#include <Arduino.h>

#define FREE 0
#define ENTRY 1
#define EXIT 2

class zoneMultiPath
{
    public:
        zoneMultiPath();
        zoneMultiPath(void (*actionFree)(), void (*actionBusy)());
        void initConsole (int bauds = 9600);
        void initControl (int pinFreeLed, int pinBusyLed, int pinButton);
        void initCommand (int pinLight, int pinFreeZone, int pinBusyZone);
        void initRailroadCrossing (int sensorsNumber, int zoneNumber, int waiting = 1000);
        void initSensor (int Pin, bool Active, int Zone,char* Name = "");
        void Loop();


    protected:
    private:
        void freeZoneManagement();
        void actionFreeZone();
        void busyZoneManagement();
        void actionBusyZone();
        byte checkBusyZone ();
        void testResetButton();
        void (*_actionFree)();
        void (*_actionBusy)();
        int sensorsNB = 0;
        int sensorIndex = 0;
        int zoneNB = 0;
        int waitingTime = 1000;
        int freeLedPin;
        int busyLedPin;
        int buttonPin;
        int lightPin;
        int freeZonePin;
        int busyZonePin;
        struct Tzone {
            bool busy;
            int state;
            int entry_sensor_number;
            int exit_sensor_number;
            };
        Tzone *busyZone;
        struct Tsensor {
            char* name;
            int pin;
            bool activeLowHigh = HIGH;
            int zoneNumber;
            int predState;
            };
        Tsensor *sensor;
        bool busyCPT = false;
        bool freeCPT = true;
        bool console = false;
        bool command = false;
        bool control = false;
        bool railroadCrossing = false;
};

#endif // ZONEMULTIPATH_H
